/* ----------------------------------------------------------------------------- */
/*	MAPt@CR[hTCY擾 asm ɕϊc[					 */
/* ============================================================================= */
/*	2009/12/13	t.hara															 */
/* ----------------------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* ----------------------------------------------------------------------------- */
static void usage( const char *p_name ) {

	printf( "Usage> %s <in.map> <out.asm> <prefix>\n", p_name );
}

/* ----------------------------------------------------------------------------- */
static void get_code_size( FILE *p_out, FILE *p_in, const char *p_prefix ) {
	char s_line[1024];
	int code_start, code_size;
	int found = 0;

	while( !feof(p_in) ) {
		s_line[0] = '\0';
		fgets( s_line, sizeof(s_line), p_in );
		if( memcmp( s_line, "CODE ", 5 ) == 0 ) {
			found = 1;
			break;
		}
	}
	if( found == 0 ) {
		fprintf( stderr, "ERROR: CODEZOg܂\n" );
		return;
	}
	code_start = 0;
	code_size = 0;
	sscanf( s_line, "CODE                               %4X   %4X", &code_start, &code_size );
	fprintf( p_out, "; -------------------------------------------------\n" );
	fprintf( p_out, "; auto generated by codesize.exe\n" );
	fprintf( p_out, "; -------------------------------------------------\n" );
	fprintf( p_out, "%sCODE_ADDR = 0x%04X\n", p_prefix, code_start );
	fprintf( p_out, "%sCODE_SIZE = 0x%04X\n", p_prefix, code_size );
}

/* ----------------------------------------------------------------------------- */
int main( int argc, char *argv[] ) {
	FILE *p_in, *p_out;

	printf( "CODE segment size getter\n" );
	printf( "====================================================================\n" );
	printf( "(C)2009 t.hara\n" );

	if( argc < 4 ) {
		usage( argv[0] );
		return 1;
	}
	p_in = fopen( argv[1], "r" );
	if( p_in == NULL ) {
		fprintf( stderr, "ERRROR: %s J܂\n", p_in );
		return 2;
	}
	p_out = fopen( argv[2], "w" );
	if( p_out == NULL ) {
		fprintf( stderr, "ERRROR: %s ܂\n", p_out );
		return 3;
	}
	get_code_size( p_out, p_in, argv[3] );
	fclose( p_out );
	fclose( p_in );
	return 0;
}
