/* ----------------------------------------------------------------------------- */
/*	16bit unsigned  8bit unsigned												 */
/* ============================================================================= */
/*	2009/12/09 t.hara															 */
/* ----------------------------------------------------------------------------- */

#include <stdio.h>

/* ----------------------------------------------------------------------------- */
/*	dividend ͊鐔 (0`65535), divisor ͊鐔 (0`255)					 */
/*	*p_quotient = dividend / divisor											 */
/*	*p_residual = dividend % divisor											 */
/*	Ԓl: 1 , 0 s([)												 */
/* ----------------------------------------------------------------------------- */
static int div16by8( int dividend, int divisor, int* p_quotient, int* p_residual ) {
	int sub, quotient, residual, count;

	if( divisor == 0 ) {
		return 0;
	}
	count = 1;
	for( sub = divisor; (sub & 0x8000) == 0; sub <<= 1 ) {
		count++;
	}
	residual = dividend;
	quotient = 0;
	while( count ) {
		quotient <<= 1;
		if( residual >= sub ) {
			residual -= sub;
			quotient += 1;
		}
		sub >>= 1;
		count--;
	}
	*p_residual = residual;
	*p_quotient = quotient;
	return 1;
}

/* ----------------------------------------------------------------------------- */
int main( void ) {
	int i, j, q, r, ref_q, ref_r;

	ref_q = 0;
	ref_r = 0;
	for( j = 0; j < 256; j++ ) {
		printf( "%d/255\n", j );
		for( i = 0; i < 65536; i++ ) {
			/* t@Xl */
			if( j ) {
				ref_q = i / j;
				ref_r = i % j;
			}
			/* eXg^[Qbg */
			if( j == 0 ) {
				if( div16by8( i, j, &q, &r ) != 0 ) {
					printf( "ERROR: %d / %d = %d ... %d (ref: [Z)\n", i, j, q, r );
				}
			}
			else if( div16by8( i, j, &q, &r ) == 0 ) {
				printf( "ERROR: %d / %d = [Z  (ref: %d ... %d)\n", i, j, ref_q, ref_r );
			}
			else if( q != ref_q || r != ref_r ) {
				printf( "ERROR: %d / %d = %d ... %d (ref: %d ... %d)\n", i, j, q, r, ref_q, ref_r );
			}
		}
	}
	printf( "completed.\n" );
	return 0;
}
