; ------------------------------------------------------------------------------
;	BGM Driver music player
; ==============================================================================
;	2009/12/28	t.hara
; ------------------------------------------------------------------------------

		.include	"msx.asm"
		.include	"bgmdrv_chinfo.asm"
		.include	"bgmdrv_vibrato_h.asm"
		.include	"bgmdrv_envelope_h.asm"

		.globl		bgmdrv_music_data_top

		.area	CODE (ABS)

; ------------------------------------------------------------------------------
;	ȃf[^R[h
; ------------------------------------------------------------------------------

;	K
TONE_C	= 0
TONE_CS	= 1
TONE_D	= 2
TONE_DS	= 3
TONE_E	= 4
TONE_F	= 5
TONE_FS	= 6
TONE_G	= 7
TONE_GS	= 8
TONE_A	= 9
TONE_AS	= 10
TONE_B	= 11

;	K (KeyOff)
KON_C	= 12
KON_CS	= 13
KON_D	= 14
KON_DS	= 15
KON_E	= 16
KON_F	= 17
KON_FS	= 18
KON_G	= 19
KON_GS	= 20
KON_A	= 21
KON_AS	= 22
KON_B	= 23

;	K (KeyOn)
KOFF_C	= 24
KOFF_CS	= 25
KOFF_D	= 26
KOFF_DS	= 27
KOFF_E	= 28
KOFF_F	= 29
KOFF_FS	= 30
KOFF_G	= 31
KOFF_GS	= 32
KOFF_A	= 33
KOFF_AS	= 34
KOFF_B	= 35

; 
VOL		= 36		; ʐΎw
VOLI	= 27		; ʃCNg
VOLD	= 28		; ʃfNg

; F
INST	= 29		; FwA2byte Ff[^̑΃AhXiΊ̓f[^̐擪j

; IN^[u
OCT		= 30		; IN^[uΎwA1byte  3bit IN^[uli0`7  O1`O8 ɑΉj
OCTI	= 31		; IN^[uCNg
OCTD	= 32		; IN^[ufNg

; ru[g
VIB		= 33		; ru[gwA2byte ru[gf[^̑΃AhXiΊ̓f[^̐擪j

; sb`xh
PITCH	= 34		; sb`xhw

; 
RATIO	= 25		; wA1byte  3bit i0`7  Q1`Q8 ɑΉj

; `
ERR		= 36		;

; ------------------------------------------------------------------------------
;	ȃf[^̊荞ݓ
;	input:
;		ix	...	`l̃AhX
;	output:
;		Ȃ
;	break:
;		ׂ
;	comment:
;		P`l
; ------------------------------------------------------------------------------
bgmdrv_music_single::
		; ȃf[^̑ҋ@ԂH
		ld		l, CH_WAIT_L(ix)
		ld		h, CH_WAIT_H(ix)
		ld		a, l
		or		h
		jp		z, bgmdrv_music_inc
		dec		hl
		ld		CH_WAIT_L(ix), l
		ld		CH_WAIT_H(ix), h
		; `FbN
		call	bgmdrv_envelope_check_keyoff
		ret		z								; ł KeyOffł΁AȂ
		ld		l, CH_KEYOFF_L(ix)
		ld		h, CH_KEYOFF_H(ix)
		ld		a, l
		or		h
		jp		z, bgmdrv_envelope_keyoff		; KeyOff ɂĔ
		dec		hl
		ld		CH_KEYOFF_L(ix), l
		ld		CH_KEYOFF_H(ix), h
		ret
		; ̃f[^֐i
bgmdrv_music_inc:
		ld		l, CH_DATA_IDX_L(ix)
		ld		h, CH_DATA_IDX_H(ix)
		ld		a, l
		or		h
		ret		z								; ~(hl=0)ȂAȂ
		ld		a, (hl)
		inc		hl
		; G[`FbN
		cp		#ERR
		jp		nc, bgmdrv_music_stop_single
		; ȃf[^̃R[hɑΉ鏈[`̃AhX𓾂
		ld		e, a
		rlc		e
		ld		d, #0
		ex		de, hl							; de = ȃf[^̎̃AhX
		ld		bc, #bgmdrv_music_cmd_table
		add		hl, bc
		ld		c, (hl)
		inc		hl
		ld		h, (hl)
		ld		l, c							; hl = [`̃AhX
		jp		(hl)							; a = ȃf[^̃R[h

; ------------------------------------------------------------------------------
;	ĐJn
;	input:
;		ix	...	`l̃AhX
;		hl	...	ȃf[^̐擪AhX
;	output:
;		Ȃ
;	break:
;		a, b, c, d, e, f
;	comment:
;		P`lB֏ԂŌĂԂƁB
; ------------------------------------------------------------------------------
bgmdrv_music_play_single::
		push	hl
		call	bgmdrv_music_stop_single
		pop		hl
		ld		CH_DATA_IDX_L(ix), l
		ld		CH_DATA_IDX_H(ix), h
		xor		a
		ld		CH_WAIT_L(ix), a
		ld		CH_WAIT_H(ix), a
		ret

; ------------------------------------------------------------------------------
;	Đ~
;	input:
;		ix	...	`l̃AhX
;	output:
;		Ȃ
;	break:
;		b, c, d, e, f, h, l
;	comment:
;		P`lB֏ԂŌĂԂƁB
; ------------------------------------------------------------------------------
bgmdrv_music_stop_single::
		push	ix
		pop		de
		ld		hl, #chinfo_init_data
		ld		bc, #CH_INFO_SIZE
		ldir
		ret

; ------------------------------------------------------------------------------
;	ȃf[^: g[Đ(KeyOn, KeyOffL)
;	input:
;		ix	...	`l̃AhX
;		a	...	g[ԍ
;		de	...	ȃf[^̎̃AhX
;	output:
;		Ȃ
;	break:
;		ׂ
;	comment:
;		Ȃ
; ------------------------------------------------------------------------------
tone_proc:
		; gݒlXV
		call	update_base_freq
		; XV
		call	update_wait
		ld		CH_DATA_IDX_L(ix), e
		ld		CH_DATA_IDX_H(ix), d
		call	update_keyoff_timing
		; KeyOn
		call	bgmdrv_envelope_keyon
		ret

; ------------------------------------------------------------------------------
;	ȃf[^: g[Đ(KeyOnL, KeyOff)
;	input:
;		ix	...	`l̃AhX
;		a	...	g[ԍ
;		de	...	ȃf[^̎̃AhX
;	output:
;		Ȃ
;	break:
;		ׂ
;	comment:
;		Ȃ
; ------------------------------------------------------------------------------
kon_proc:
		; gݒlXV
		call	update_base_freq
		; XV
		call	update_wait
		ld		CH_DATA_IDX_L(ix), e
		ld		CH_DATA_IDX_H(ix), d
		; KeyOff҂ԂXV
		ld		a, #255
		ld		CH_KEYOFF_L(ix), a
		ld		CH_KEYOFF_H(ix), a
		; KeyOn
		call	bgmdrv_envelope_keyon
		ret

; ------------------------------------------------------------------------------
;	ȃf[^: g[Đ(KeyOn, KeyOffL)
;	input:
;		ix	...	`l̃AhX
;		a	...	g[ԍ
;		de	...	ȃf[^̎̃AhX
;	output:
;		Ȃ
;	break:
;		ׂ
;	comment:
;		Ȃ
; ------------------------------------------------------------------------------
koff_proc:
		; gݒlXV
		call	update_base_freq
		; XV
		call	update_wait
		ld		CH_DATA_IDX_L(ix), e
		ld		CH_DATA_IDX_H(ix), d
		call	update_keyoff_timing
		ret

; ------------------------------------------------------------------------------
;	ȃf[^: Ff[^ύX
;	input:
;		ix	...	`l̃AhX
;		de	...	ȃf[^̎̃AhX
;	output:
;		Ȃ
;	break:
;		ׂ
;	comment:
;		Ȃ
; ------------------------------------------------------------------------------
inst_proc:
		; Ff[^̑΃AhX擾
		ex		de, hl
		ld		e, (hl)
		inc		hl
		ld		d, (hl)
		inc		hl
		ld		CH_DATA_IDX_L(ix), l
		ld		CH_DATA_IDX_H(ix), h
		; ΃AhX֕ϊ
		ld		hl, #bgmdrv_music_data_top
		add		hl, de
		; `lf[^ɏ
		ld		CH_INST_L(ix), l
		ld		CH_INST_H(ix), h
		; ȎQƂȂ悤Ɋe폈~
		call	bgmdrv_envelope_force_stop
		ret

; ------------------------------------------------------------------------------
;	ȃf[^: ʕύX
;	input:
;		ix	...	`l̃AhX
;		de	...	ȃf[^̎̃AhX
;	output:
;		Ȃ
;	break:
;		ׂ
;	comment:
;		Ȃ
; ------------------------------------------------------------------------------
vol_proc:
		; ʒl擾
		ld		a, (de)
		inc		de
		ld		CH_DATA_IDX_L(ix), e
		ld		CH_DATA_IDX_H(ix), d
		; `lf[^ɏ
		ld		CH_VOL(ix), a
		ret

; ------------------------------------------------------------------------------
;	ȃf[^: ʑ
;	input:
;		ix	...	`l̃AhX
;		de	...	ȃf[^̎̃AhX
;	output:
;		Ȃ
;	break:
;		ׂ
;	comment:
;		Ȃ
; ------------------------------------------------------------------------------
voli_proc:
		ld		CH_DATA_IDX_L(ix), e
		ld		CH_DATA_IDX_H(ix), d
		; `lf[^ɏ
		ld		a, CH_VOL(ix)
		inc		a
		cp		#16
		ret		nc
		ld		CH_VOL(ix), a
		ret

; ------------------------------------------------------------------------------
;	ȃf[^: ʌ
;	input:
;		ix	...	`l̃AhX
;		de	...	ȃf[^̎̃AhX
;	output:
;		Ȃ
;	break:
;		ׂ
;	comment:
;		Ȃ
; ------------------------------------------------------------------------------
vold_proc:
		ld		CH_DATA_IDX_L(ix), e
		ld		CH_DATA_IDX_H(ix), d
		; `lf[^ɏ
		ld		a, CH_VOL(ix)
		dec		a
		ret		m
		ld		CH_VOL(ix), a
		ret

; ------------------------------------------------------------------------------
;	ȃf[^: IN^[uύX
;	input:
;		ix	...	`l̃AhX
;		de	...	ȃf[^̎̃AhX
;	output:
;		Ȃ
;	break:
;		ׂ
;	comment:
;		Ȃ
; ------------------------------------------------------------------------------
oct_proc:
		; IN^[ul擾
		ld		a, (de)
		inc		de
		ld		CH_DATA_IDX_L(ix), e
		ld		CH_DATA_IDX_H(ix), d
		; `lf[^ɏ
		ld		CH_OCTAVE(ix), a
		ret

; ------------------------------------------------------------------------------
;	ȃf[^: IN^[u
;	input:
;		ix	...	`l̃AhX
;		de	...	ȃf[^̎̃AhX
;	output:
;		Ȃ
;	break:
;		ׂ
;	comment:
;		Ȃ
; ------------------------------------------------------------------------------
octi_proc:
		ld		CH_DATA_IDX_L(ix), e
		ld		CH_DATA_IDX_H(ix), d
		; `lf[^ɏ
		ld		a, CH_OCTAVE(ix)
		inc		a
		cp		#8
		ret		nc
		ld		CH_OCTAVE(ix), a
		ret

; ------------------------------------------------------------------------------
;	ȃf[^: IN^[u
;	input:
;		ix	...	`l̃AhX
;		de	...	ȃf[^̎̃AhX
;	output:
;		Ȃ
;	break:
;		ׂ
;	comment:
;		Ȃ
; ------------------------------------------------------------------------------
octd_proc:
		ld		CH_DATA_IDX_L(ix), e
		ld		CH_DATA_IDX_H(ix), d
		; `lf[^ɏ
		ld		a, CH_OCTAVE(ix)
		dec		a
		ret		m
		ld		CH_OCTAVE(ix), a
		ret

; ------------------------------------------------------------------------------
;	ȃf[^: ύX
;	input:
;		ix	...	`l̃AhX
;		de	...	ȃf[^̎̃AhX
;	output:
;		Ȃ
;	break:
;		ׂ
;	comment:
;		Ȃ
; ------------------------------------------------------------------------------
ratio_proc:
		; 擾
		ld		a, (de)
		inc		de
		ld		CH_DATA_IDX_L(ix), e
		ld		CH_DATA_IDX_H(ix), d
		; `lf[^ɏ
		ld		CH_OCTAVE(ix), a
		ret

; ------------------------------------------------------------------------------
;	ȃf[^: ru[gύX
;	input:
;		ix	...	`l̃AhX
;		de	...	ȃf[^̎̃AhX
;	output:
;		Ȃ
;	break:
;		ׂ
;	comment:
;		Ȃ
; ------------------------------------------------------------------------------
vib_proc:
		; ru[gf[^̑΃AhX擾
		ex		de, hl
		ld		e, (hl)
		inc		hl
		ld		d, (hl)
		inc		hl
		ld		CH_DATA_IDX_L(ix), l
		ld		CH_DATA_IDX_H(ix), h
		; ΃AhX֕ϊ
		ld		hl, #bgmdrv_music_data_top
		add		hl, de
		; `lf[^ɏ
		ld		a, (hl)
		inc		hl
		ld		CH_WAVE_SIZE(ix), a
		ld		a, (hl)
		inc		hl
		ld		CH_WAVE_REP(ix), a
		ld		CH_WAVE_REF(ix), #0
		ld		CH_WAVE_OFFSET(ix), #0
		ld		CH_WAVE_TBL_L(ix), l
		ld		CH_WAVE_TBL_H(ix), h
		ret

; ------------------------------------------------------------------------------
;	ȃf[^: sb`xh
;	input:
;		ix	...	`l̃AhX
;		de	...	ȃf[^̎̃AhX
;	output:
;		Ȃ
;	break:
;		ׂ
;	comment:
;		Ȃ
; ------------------------------------------------------------------------------
pitch_proc:
		;; 
		ret

; ------------------------------------------------------------------------------
;	ȃf[^Tu: gݒlXV
;	input:
;		ix	...	`l̃AhX
;		a	...	g[ԍ (0`11)
;	output:
;		Ȃ
;	break:
;		a, b, c, h, l, f
;	comment:
;		Ȃ
; ------------------------------------------------------------------------------
update_base_freq:
		; freq_table ̃CfbNXlɕϊ
		rlca
		ld		l, a
		ld		h, #0
		; ΃AhXɕϊ
		ld		bc, #freq_table
		add		hl, bc
		; gݒl擾
		ld		c, (hl)
		inc		hl
		ld		b, (hl)
		; gƂĐݒ肷
		ld		CH_TONE_BASE_L(ix), c
		ld		CH_TONE_BASE_H(ix), b
		ret

; ------------------------------------------------------------------------------
;	ȃf[^Tu: XV
;	input:
;		ix	...	`l̃AhX
;		de	...	ȃf[^̉̃AhX
;	output:
;		Ȃ
;	break:
;		a, b, c, h, l, f
;	comment:
;		Ȃ
; ------------------------------------------------------------------------------
update_wait:
		push	de
		pop		iy
		ld		hl, #0
		ld		bc, #0
update_wait_loop:
		ld		c, (iy)
		inc		iy
		add		hl, bc					; ǂ񂾒lϕ
		ld		a, c
		inc		a
		jp		z, update_wait_loop		; 255ꍇAɑ̂ŌJԂēǂ
		; XV
		ld		CH_WAIT_L(ix), l
		ld		CH_WAIT_H(ix), h
		push	iy
		pop		de
		ret

; ------------------------------------------------------------------------------
;	ȃf[^Tu: ݒ肳Ă鉹ƂKeyOff^C~OXV
;	input:
;		ix	...	`l̃AhX
;		de	...	ȃf[^̉̃AhX
;	output:
;		Ȃ
;	break:
;		a, b, c, h, l, f
;	comment:
;		Ȃ
; ------------------------------------------------------------------------------
update_keyoff_timing:
		; ݂̉擾
		ld		l, CH_WAIT_L(ix)
		ld		h, CH_WAIT_H(ix)
		; 擾
		ld		a, CH_RATIO(ix)
		; HL =  *  / 8
		ld		c, l
		ld		b, h
		ld		hl, #0					; HL = BC(13bit) * A(3bit)
		bit		2, a
		jp		z, update_keyoff_timing1
		add		hl, bc
update_keyoff_timing1:
		add		hl, hl
		bit		1, a
		jp		z, update_keyoff_timing2
		add		hl, bc
update_keyoff_timing2:
		add		hl, hl
		bit		0, a
		jp		z, update_keyoff_timing3
		add		hl, bc
update_keyoff_timing3:
		sra		h						; / 8
		rr		l
		sra		h
		rr		l
		sra		h
		rr		l
		; KeyOff҂ԂXV
		ld		CH_KEYOFF_L(ix), l
		ld		CH_KEYOFF_H(ix), h
		ret

; ------------------------------------------------------------------------------
;	ge[u
;	PSG_CLOCK[MHz] * 1000000 / (16 * target_frequency[Hz])
;	PSG_CLOCK = 1.7897725[MHz]
;
;	440Hz(O4A) ̐ݒĺA1.7897725 * 1000000 / (16 * 440) = 254.2290483  254
;	                                                        덷 = 0.2290483
;	tZƎۂ̍ĐgɂȂ
;	PSG_CLOCK[MHz] * 1000000 / (16 * target_frequency[Hz]) = value
;	1 / target_frequency[Hz] = value * 16 / (PSG_CLOCK[MHz] * 1000000)
;	target_frequency[Hz] = PSG_CLOCK[MHz] * 1000000 / (value * 16)
;
;	value = 254 ̏ꍇB
;	1.7897725 * 1000000 / (254 * 16) = 440.39677657[Hz]
;
;	ۂ߂ɂĔ덷Âɂ萶鉹ÝA0.39677657 ƂȂB
;	
;	ቹł́Agɑ΂덷g̔䂪ߖł邪A
;	ł́Agɑ΂덷g̔䂪傫߁AȂ艹ĕB
;	MSX  PSG ̍sƂ̂́AɗRB
;	PSG_CLOCK ΉP邪Ax͕䃌WX^̃rbg
;	ɂĒႢKĐłȂȂ邽߁APSG ̐\EƂB
; ------------------------------------------------------------------------------
freq_table:
		;		    C     C#      D     D#      E      F     F#      G     G#      A     A#      B
		.dw		#3420, #3228, #3047, #2876, #2714, #2562, #2418, #2282, #2154, #2033, #1919, #1811	; O1
		.dw		#1710, #1614, #1523, #1438, #1357, #1281, #1209, #1141, #1077, #1016,  #959,  #905	; O2
		.dw		 #855,  #807,  #761,  #719,  #678,  #640,  #604,  #570,  #538,  #508,  #479,  #452	; O3
		.dw		 #427,  #403,  #380,  #359,  #339,  #320,  #302,  #285,  #269,  #254,  #239,  #226	; O4
		.dw		 #213,  #201,  #190,  #179,  #169,  #160,  #151,  #142,  #134,  #127,  #119,  #113	; O5
		.dw		 #106,  #100,   #95,   #89,   #84,   #80,   #75,   #71,   #67,   #63,   #59,   #56	; O6
		.dw		  #53,   #50,   #47,   #44,   #42,   #40,   #37,   #35,   #33,   #31,   #29,   #28	; O7
		.dw		  #26,   #25,   #23,   #22,   #21,   #20,   #18,   #17,   #16,   #15,   #14,   #14	; O8

; ------------------------------------------------------------------------------
;	`l񏉊le[u
; ------------------------------------------------------------------------------
chinfo_init_data:
		.db		#0				; CH_DATA_IDX_L		 ȃf[^̎QƃAhX
		.db		#0				; CH_DATA_IDX_H		 ȃf[^̎QƃAhX
		.db		#0				; CH_WAIT_L			 ȃf[^҂ԉ
		.db		#0				; CH_WAIT_H			 ȃf[^҂ԏ
		.db		#0				; CH_KEYOFF_L		 ȃf[^҂ԉ
		.db		#0				; CH_KEYOFF_H		 ȃf[^҂ԏ
		.db		#0				; CH_TONE_BASE_L	 gl
		.db		#0				; CH_TONE_BASE_H	 gl
		.db		#0				; CH_TONE_OFFSET	 g[ωg`TvOf[^
		.db		#15				; CH_VOL			 ʒl
		.db		#0				; CH_ENV_STATE		 Gx[v (CH_ENV_STATE_XX i[)
		.db		#0				; CH_ENV_VOL		 Gx[vg`݂̌̏o
		.dw		#default_inst	; CH_INST			 I𒆂̉Ff[^AhX
		.db		#0				; CH_OCTAVE			 ݂̃IN^[u
		.db		#0				; CH_RATIO			 ݂̉
		.dw		#default_wave	; CH_WAVE_TBL		 ru[gg`f[^̊i[AhX
		.db		#0				; CH_WAVE_REF		 ru[gg`f[^̃TvOʒu
		.db		#1				; CH_WAVE_SIZE		 ru[gg`f[^̃TCY
		.db		#0				; CH_WAVE_REP		 ru[gg`f[^̃[vJnʒu
		.db		#0				; CH_WAVE_OFFSET	 ru[gg`TvOf[^

; ------------------------------------------------------------------------------
;	ru[gg`
; ------------------------------------------------------------------------------
default_wave:
		.db		#0				; WAVE

; ------------------------------------------------------------------------------
;	Ff[^
; ------------------------------------------------------------------------------
default_inst:
		.db		#255			; INST_AR			 A^bNCg
		.db		#1				; INST_DR			 fBPCCg
		.db		#240			; INST_SL			 TXeBx
		.db		#2				; INST_SR			 TXeBCg
		.db		#16				; INST_RR			 [XCg
		.db		#0				; INST_NOISE		 mCY
		.db		#0				; INST_MIX			 ~bNX 0 = g[̂, 1 = mCŶ, 2 = g[{mCY
		.db		#1				; INST_WAVE_SIZE	 g[ωg`̃TCY
		.db		#0				; INST_WAVE_REP		 g[ωg`̃[vJnʒu
		.db		#0				; INST_WAVE			 g[ωg`f[^

; ------------------------------------------------------------------------------
;	[`AhXe[u
; ------------------------------------------------------------------------------
bgmdrv_music_cmd_table:
		.dw		#tone_proc		; TONE_C
		.dw		#tone_proc		; TONE_CS
		.dw		#tone_proc		; TONE_D
		.dw		#tone_proc		; TONE_DS
		.dw		#tone_proc		; TONE_E
		.dw		#tone_proc		; TONE_F
		.dw		#tone_proc		; TONE_FS
		.dw		#tone_proc		; TONE_G
		.dw		#tone_proc		; TONE_GS
		.dw		#tone_proc		; TONE_A
		.dw		#tone_proc		; TONE_AS
		.dw		#tone_proc		; TONE_B
		.dw		#kon_proc		; KON_C
		.dw		#kon_proc		; KON_CS
		.dw		#kon_proc		; KON_D
		.dw		#kon_proc		; KON_DS
		.dw		#kon_proc		; KON_E
		.dw		#kon_proc		; KON_F
		.dw		#kon_proc		; KON_FS
		.dw		#kon_proc		; KON_G
		.dw		#kon_proc		; KON_GS
		.dw		#kon_proc		; KON_A
		.dw		#kon_proc		; KON_AS
		.dw		#kon_proc		; KON_B
		.dw		#koff_proc		; KOFF_C
		.dw		#koff_proc		; KOFF_CS
		.dw		#koff_proc		; KOFF_D
		.dw		#koff_proc		; KOFF_DS
		.dw		#koff_proc		; KOFF_E
		.dw		#koff_proc		; KOFF_F
		.dw		#koff_proc		; KOFF_FS
		.dw		#koff_proc		; KOFF_G
		.dw		#koff_proc		; KOFF_GS
		.dw		#koff_proc		; KOFF_A
		.dw		#koff_proc		; KOFF_AS
		.dw		#koff_proc		; KOFF_B
		.dw		#vol_proc		; VOL
		.dw		#voli_proc		; VOLI
		.dw		#vold_proc		; VOLD
		.dw		#inst_proc		; INST
		.dw		#oct_proc		; OCT
		.dw		#octi_proc		; OCTI
		.dw		#octd_proc		; OCTD
		.dw		#vib_proc		; VIB
		.dw		#pitch_proc		; PITCH
		.dw		#ratio_proc		; RATIO

; ==============================================================================
;	[NGA
; ==============================================================================

; ------------------------------------------------------------------------------
;	ȃf[^
; ------------------------------------------------------------------------------
bgmdrv_chinfo0:
		.ds		CH_INFO_SIZE
bgmdrv_chinfo1:
		.ds		CH_INFO_SIZE
bgmdrv_chinfo2:
		.ds		CH_INFO_SIZE
