; ------------------------------------------------------------------------------
;	BGM Driver statement
; ==============================================================================
;	2009/12/14	t.hara
; ------------------------------------------------------------------------------

		.include	"msx.asm"
		.include	"vsync_h.asm"
		.include	"bgmdrv_memory_h.asm"

		.area	CODE (ABS)

; ------------------------------------------------------------------------------
;	@͏
; ------------------------------------------------------------------------------
bgmdrv_statement::
		; ʒuX^bN֑ޔ
		push	hl
		; ړ "BGM" ̕]
		ld		a, (PROCNM + 0)
		cp		#"B"
		jp		nz, bgmdrv_failed
		ld		a, (PROCNM + 1)
		cp		#"G"
		jp		nz, bgmdrv_failed
		ld		a, (PROCNM + 2)
		cp		#"M"
		jp		nz, bgmdrv_failed
		; ړȍ~̕r
		ld		hl, #command_name
compare_name_loop:
		ld		e, (hl)
		inc		hl
		ld		d, (hl)
		inc		hl
		ld		a, e					; ԕH
		or		d
		jp		z, bgmdrv_failed		; ԕȂvR}hȂƂm
		ld		ix, #PROCNM + 3
compare_string_loop:
		ld		a, (ix)
		cp		(hl)
		jp		nz, compare_failed
		or		a
		jp		z, compare_success
		inc		hl
		inc		ix
		jp		compare_string_loop
compare_failed:
		inc		hl
		ld		a, (hl)
		or		a
		jp		nz, compare_failed
		inc		hl
		jp		compare_name_loop
bgmdrv_failed:
		pop		hl
		scf
		ret
compare_success:
		ex		de, hl
		jp		(hl)

; ------------------------------------------------------------------------------
;	CALL BGMDRV ̏
;	BGMDRV 
; ------------------------------------------------------------------------------
cmd_bgmdrv::
		call	vsync_init			; ^C}[荞ݏ
		call	mem_init			; }l[W
		pop		hl					; AhX
		or		a
		ret

; ------------------------------------------------------------------------------
;	CALL BGMWAIT(wait_time) ̏
;	w̎Ԃҋ@
; ------------------------------------------------------------------------------
cmd_bgmwait::
		pop		hl					; AhX
		call	get_next_char
		cp		#0x28				; '('
		jp		nz, err_illegal_function_call
		inc		hl

		ld		ix, #FRMQNT			; 2byte]֐̃AhX
		call	CALBAS				; ]Ăяo (G[Ɩ߂ĂȂ)

		call	get_next_char
		cp		#0x29				; ')'
		jp		nz, err_illegal_function_call
		inc		hl
		ex		de, hl
		call	vsync_wait_time		; w̎Ԃҋ@
		ex		de, hl
		or		a
		ret

; ------------------------------------------------------------------------------
;	CALL BGMCLRKB ̏
;	L[obt@NA
; ------------------------------------------------------------------------------
cmd_bgmclrkb::
		call	KILBUF				; L[obt@NA
		pop		hl
		or		a
		ret

; ------------------------------------------------------------------------------
;	CALL BGMCLRDATA ̏
;	ɓo^f[^ׂď
; ------------------------------------------------------------------------------
cmd_clrdata::
		call	mem_init			; }l[W
		pop		hl
		or		a
		ret

; ------------------------------------------------------------------------------
;	CALL BGMSETDATA(str_data) ̏
;	Ƀf[^o^
; ------------------------------------------------------------------------------
cmd_setdata::
		pop		hl					; AhX
		call	get_next_char
		cp		#0x28				; '('
		jp		nz, err_illegal_function_call
		inc		hl

		ld		ix, #FRMEVL			; ]֐̃AhX
		call	CALBAS				; ]Ăяo (G[Ɩ߂ĂȂ)
		push	hl					; eLXg̃AhXޔ
		ld		ix, #FRESTR			; o^ăXgOfXNv^([TCY][ʃAhX][ʃAhX]3byte)̃AhX擾
		call	CALBAS				; o^Ăяo (G[Ɩ߂ĂȂ)
		ld		a, (hl)				; ̒𓾂
		inc		hl
		ld		e, (hl)				; de ɕi[AhX
		inc		hl
		ld		d, (hl)

		bit		0, a				; ̒ȂG[
		jp		nz, err_illegal_function_call_with_pop

		rrca						; oCgɕϊ
		ld		c, a
		ld		b, #0
		call	mem_alloc			; w̃oCgm
		jp		c, err_out_of_memory_with_pop
		ld		b, a
cmd_setdata_loop:
		ld		a, (de)				; ŏ̕
		call	hex_to_bin
		inc		de
		rlca
		rlca
		rlca
		rlca
		ld		c, a
		ld		a, (de)				; ̕
		call	hex_to_bin
		inc		de
		or		c
		ld		(hl), a
		inc		hl
		djnz	cmd_setdata_loop

		pop		hl					; eLXg̃AhX𕜋A
		call	get_next_char
		cp		#0x29				; ')'
		jp		nz, err_illegal_function_call
		inc		hl
		or		a
		ret

; ------------------------------------------------------------------------------
;	BASIC ERROR: Illegal Function Call 𔭐
;	:
;		--
;	o:
;		--
;	j:
;		--
;	l:
;		߂Ȃ
; ------------------------------------------------------------------------------
err_illegal_function_call_with_pop::
		pop		hl
err_illegal_function_call::
		ld		ix, #BASERR			; G[
		ld		e, #5				; Illegal Function Call
		jp		CALBAS

; ------------------------------------------------------------------------------
;	BASIC ERROR: Illegal Function Call 𔭐
;	:
;		--
;	o:
;		--
;	j:
;		--
;	l:
;		߂Ȃ
; ------------------------------------------------------------------------------
err_out_of_memory_with_pop::
		pop		hl
err_out_of_memory::
		ld		ix, #BASERR			; G[
		ld		e, #7				; Illegal Function Call
		jp		CALBAS

; ------------------------------------------------------------------------------
;	̕擾
;	:
;		HL	...	eLXg̃AhX
;	o:
;		HL	...	擾̃AhX
;	j:
;		A, F
; ------------------------------------------------------------------------------
get_next_char::
		ld		a, (hl)
		cp		#0x20				; ' '
		ret		nz
		inc		hl
		jp		get_next_char

; ------------------------------------------------------------------------------
;	P̂PUioCilɕϊ
;	:
;		A	...	R[h
;	o:
;		A	...	ϊ
;	j:
;		A, F
; ------------------------------------------------------------------------------
hex_to_bin::
		or		#0x20				; 0`90`9, A`Za`z, a`za`z, ̑ don't care
		sub		#0x30
		cp		#10
		ret		c
		sub		#(0x31 - 10)
		ret

; ------------------------------------------------------------------------------
;	eXgp_~[
; ------------------------------------------------------------------------------
__cmd_test:
		call	BEEP
		pop		hl
		or		a
		ret

; ------------------------------------------------------------------------------
;	߈ꗗ
; ------------------------------------------------------------------------------
command_name:
		.dw		#cmd_bgmdrv
		.ascii	"DRV\0"
		.dw		#cmd_bgmwait
		.ascii	"WAIT\0"
		.dw		#cmd_bgmclrkb
		.ascii	"CLRKB\0"
		.dw		#cmd_clrdata
		.ascii	"CLRDATA\0"
		.dw		#cmd_setdata
		.ascii	"SETDATA\0"
		.dw		#__cmd_test			;cmd_bgmplay
		.ascii	"PLAY\0"
		.dw		#0					; ԕ (terminator)
