; ------------------------------------------------------------------------------
;	mathematical library for Z80
;	ėpIȎZpZ͂ɏW񂷂
; ==============================================================================
;	2009/12/12	t.hara
; ------------------------------------------------------------------------------

		.area	CODE (ABS)

; ------------------------------------------------------------------------------
;	division unsigned 16bit by unsigned 8bit (de = hl / a, l = hl mod a)
;	c flag = 1: divided by zero error
;	break: a, b, c, d, e, f, h, l
; ------------------------------------------------------------------------------
math_div16by8::
		or		a
		scf
		ret		z			; divided by zero error

		ld		b, #9		; count(b) = 1+8
_for_sub_loop:
		bit		7, a
		jp		nz, _for_sub_break
		inc		b
		rlca
		jp		_for_sub_loop
_for_sub_break:
		ld		a, b		; count(a)
		ld		de, #0		; quotient(de) = 0
		ld		c, e		; sub(bc)
_while_count_loop:
		sla		e			; quotient <<= 1
		rl		d
		inc		de			; quotient += 1
		sbc		hl, de		; residual -= sub
		jp		c, _while_count_skip
		dec		de
		add		hl, de
_while_count_skip:
		srl		b			; sub >>= 1
		rr		c
		dec		a			; count--
		jp		nz, _while_count_loop
		or		a			; clear c flag
		ret
